'use strict';

const debug = require(`debug`)(`shifted-semver-increment`);
const semver = require(`semver`);

module.exports = (version, release, label) => {
  const result = semver.major(version) === 0 ?

    // Major version zero logic.
    semver.inc(
      version,
      release === `major` ?
        `minor` :
        release === `premajor` ?
          `preminor` :
          release === `preminor` || release === `prepatch` ?
            `prepatch` :
            release === `prerelease` ?
              `prerelease` :
              `patch`,
      label
    ) :

    // Non-major version zero logic.
    semver.inc(version, release, label);
  debug(`version - ${version}, release - ${release}, label - ${label}, result - ${result}`);

  return result;
};
